#include "DiscreteDynamicsWorld.h"
#include "BulletCLIMath.h"

#pragma unmanaged
#include "BulletCollision/CollisionDispatch/btDefaultCollisionConfiguration.h"
#include "BulletCollision/CollisionDispatch/btCollisionObject.h"
#pragma managed

namespace BulletCLI
{

	DiscreteDynamicsWorld::DiscreteDynamicsWorld(IDispatcher^ dispatcher,IBroadphaseInterface^ pairChache,
                    IConstraintSolver^ constraintSolver,ICollisionConfiguration^ collisionConfiguration)
	{
        this->m_p=new ::btDiscreteDynamicsWorld
            (dispatcher->GetPtr(),
            pairChache->GetPtr(),
            constraintSolver->GetPtr(),
            collisionConfiguration->GetPtr());
    }
	DiscreteDynamicsWorld::~DiscreteDynamicsWorld()
	{
		this->!DiscreteDynamicsWorld();
	}
	DiscreteDynamicsWorld::!DiscreteDynamicsWorld()
	{
        if(this->m_p!=NULL)
        {
            for(int i=m_p->getNumCollisionObjects()-1;i>=0;i--)
            {
                btCollisionObject* obj=m_p->getCollisionObjectArray()[i];
                m_p->removeCollisionObject(obj);
            }
            SAFE_DELETE(this->m_p);
        }
	}
#pragma unmanaged
    //ł͌ĂׂȂ
    void SetGravity(btDiscreteDynamicsWorld* p,float x, float y ,float z)
    {
        p->setGravity(btVector3(x,y,z));
    }
    /*Vector3* GetGravity(btDiscreteDynamicsWorld* p)
    {
        btVector3 vec= p->getGravity();
        Vector3* result=gcnew Vector3(vec[0],vec[1],vec[2]);
        return result;
    }*/
#pragma managed
    void DiscreteDynamicsWorld::SetGravity(float x, float y ,float z)
    {
        BulletCLI::SetGravity(m_p,x,y,z);
    }
    void DiscreteDynamicsWorld::StepSimulation(float timeStep, int maxSubSteps)
    {
        m_p->stepSimulation(timeStep, maxSubSteps);
    }
    
    void DiscreteDynamicsWorld::AddRigidBody(RigidBody ^body, short group, short mask)
    {
        btRigidBody* ptr=body->GetPtr();
        this->m_p->addRigidBody(ptr,group,mask);
        body->m_bRegisterd=true;
    }
    void DiscreteDynamicsWorld::AddConstraint(Generic6DofSpringConstraint^ constraint)
    {
        this->m_p->addConstraint(constraint->GetPtr());
    }
}