using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline.Processors;
using System.IO;
using System.Drawing;

namespace MikuMikuDance.XNA.Accessory
{
    /// <summary>
    /// MikuMikuDanceANZTpvZbT
    /// </summary>
    /// <remarks>ʂ̃fvZbTgƂł邪ȀꍇAXtBA}bvƃXN[@\͎gȂ</remarks>
    [ContentProcessor(DisplayName = "MikuMikuDanceANZT : MikuMikuDance for XNA")]
    public class AccessoryProcessor : ModelProcessor
    {
        /// <summary>
        /// ANZT̏
        /// </summary>
        /// <param name="input">ANZTf[^</param>
        /// <param name="context">vZbTReLXg</param>
        /// <returns>ς݃ANZTf[^</returns>
        public override ModelContent Process(NodeContent input, ContentProcessorContext context)
        {
            return base.Process(input, context);
        }
        /// <summary>
        /// eNX`̏
        /// </summary>
        /// <param name="material">}eA</param>
        /// <param name="context">vZbTReLXg</param>
        /// <returns>ς݃}eAf[^</returns>
        protected override MaterialContent ConvertMaterial(MaterialContent material, ContentProcessorContext context)
        {
            BasicMaterialContent basicMaterial = material as BasicMaterialContent;
            if (basicMaterial != null)
            {
                List<string> SpecialTexKeys = new List<string>();
                foreach (var i in basicMaterial.Textures)
                {
                    if ((!File.Exists(i.Value.Filename) && Path.GetFileName(i.Value.Filename) == "screen.bmp") ||
                        Path.GetExtension(i.Value.Filename).ToLower() == ".sph" || Path.GetExtension(i.Value.Filename).ToLower() == ".spa")
                    {//screen.bmpy.sph
                        SpecialTexKeys.Add(i.Key);
                    }
                }
                //eNX`W΍̂߂Ƀf[^˂ł̂ňo
                string sphName = "";
                foreach (var i in basicMaterial.OpaqueData)
                {
                    if (i.Key == "sphTex")
                        sphName = basicMaterial.Name;
                }
                if (sphName != "")
                    basicMaterial.OpaqueData.Remove("sphTex");
                if (SpecialTexKeys.Count > 0 || sphName != "")
                {
                    string spherePath, texPath = "";
                    if (SpecialTexKeys.Count > 0)
                        spherePath = basicMaterial.Textures[SpecialTexKeys[0]].Filename;
                    else
                        spherePath = sphName;
                    foreach (var tex in basicMaterial.Textures)
                    {
                        if (tex.Value.Filename != spherePath)
                        {
                            if (texPath != "")
                                throw new InvalidContentException(string.Format(
                                        "AccessoryProcessorscreen.bmpw肳Ă}eAɂčveNX`[1̂݁A" +
                                        "XtBA}bvw肳Ă}eAɂăeNX`v2܂ŃT|[g܂" +
                                        "̓bV̓eNX`[{0}gpĂ܂B", basicMaterial.Textures.Count));
                            texPath = sphName;
                        }
                    }
                    if (Path.GetFileName(spherePath) == "screen.bmp")
                    {
                        if (basicMaterial.Textures.Count >= 2)
                            throw new InvalidContentException(string.Format(
                                "AccessoryProcessorscreen.bmpw肳Ă}eAɂăeNX`[1݂̂T|[g܂" +
                                "̓bV̓eNX`[{0}gpĂ܂B", basicMaterial.Textures.Count));
                        EffectMaterialContent effectMaterial = new EffectMaterialContent();
                        //XN[̃GtFNg}
                        //\[Xt@C쐬ēǂݍނƂZRC@cc
                        if (!Directory.Exists("ext"))
                            Directory.CreateDirectory("ext");
                        FileStream fs = new FileStream(Path.Combine("ext", "ScreenEffect.fx"), FileMode.Create);
                        BinaryWriter bw = new BinaryWriter(fs);
                        bw.Write(Resource1.ScreenEffect);
                        bw.Close();
                        effectMaterial.Effect = new ExternalReference<EffectContent>(Path.Combine("ext", "ScreenEffect.fx"));
                        //f[^̃Rs[
                        foreach (var i in basicMaterial.OpaqueData)
                        {
                            effectMaterial.OpaqueData.Add(i.Key, i.Value);
                        }
                        effectMaterial.Name = "mmd-screen";
                        effectMaterial.Identity = basicMaterial.Identity;
                        //GtFNg}eAɕϊ
                        return base.ConvertMaterial(effectMaterial, context);
                    }
                    else if (Path.GetExtension(spherePath).ToLower() == ".sph" || Path.GetExtension(spherePath).ToLower() == ".spa")
                    {
                        //XtBA}bṽGtFNg쐬
                        EffectMaterialContent effectMaterial = new EffectMaterialContent();
                        //XtBA}bṽfBNg쐬
                        string IntDir = Path.Combine(Path.GetDirectoryName(spherePath), "ext");
                        if (!Directory.Exists(IntDir))
                            Directory.CreateDirectory(IntDir);
                        //GtFNg\[X쐬
                        FileStream fs = new FileStream(Path.Combine(IntDir, "SphereEffect.fx"), FileMode.Create);
                        BinaryWriter bw = new BinaryWriter(fs);
                        bw.Write(Resource1.SphereEffect);
                        bw.Close();
                        effectMaterial.Effect = new ExternalReference<EffectContent>(Path.Combine(IntDir, "SphereEffect.fx"));
                        //f[^̃Rs[
                        foreach (var i in basicMaterial.OpaqueData)
                        {
                            effectMaterial.OpaqueData.Add(i.Key, i.Value);
                        }
                        effectMaterial.Name = basicMaterial.Name + "-sphere";
                        effectMaterial.Identity = basicMaterial.Identity;
                        //eNX`̑݃`FbN
                        if (!File.Exists(spherePath))
                            throw new InvalidContentException(
                                "Cannot find sphere file:" + spherePath);
                        if (!string.IsNullOrEmpty(texPath) && !File.Exists(texPath))
                            throw new InvalidContentException(
                                "Cannot find sphere file:" + texPath);
                        //XtBA}bv̊gq
                        string intFilePath = Path.Combine(IntDir, Path.GetFileName(spherePath));
                        Image sphere = null;
                        try
                        {
                            sphere = new Bitmap(spherePath);
                        }
                        catch (OutOfMemoryException)
                        {
                            //œǂ߂Ȃ̂tga^
                            intFilePath += ".tga";
                            File.Copy(spherePath, intFilePath, true);//㏑ŃRs[
                        }
                        //^
                        if (sphere != null)
                        {
                            string Extention;
                            ImageExtAnalyzer.Analyze(sphere, out Extention);
                            intFilePath += Extention;
                            File.Copy(spherePath, intFilePath, true);
                        }
                        //XtBA}bv̓\t
                        effectMaterial.Textures.Add("SphereTexture", new ExternalReference<TextureContent>(intFilePath));
                        if (Path.GetExtension(spherePath).ToLower() == ".spa")
                            effectMaterial.OpaqueData.Add("SphereType", 2);
                        else
                            effectMaterial.OpaqueData.Add("SphereType", 1);
                        //ʏeNX`̓\t
                        if (!string.IsNullOrEmpty(texPath))
                        {
                            effectMaterial.Textures.Add("Texture", new ExternalReference<TextureContent>(texPath));
                            effectMaterial.OpaqueData.Add("UseTexture", 1);
                        }
                        else
                        {
                            effectMaterial.OpaqueData.Add("UseTexture", 0);
                        }

                        //GtFNg}eAɕϊ
                        return base.ConvertMaterial(effectMaterial, context);
                    }
                    else//Ȃ񂩎YH
                        throw new NotImplementedException();
                }
                else
                {
                    return base.ConvertMaterial(basicMaterial, context);
                }
            }
            else
            {//EffectMaterialContentꍇẮH
                throw new InvalidContentException(string.Format(
                    "AccessoryProcessorBasicMaterialContent݂̂T|[g܂" +
                    "̓bV{0}gpĂ܂B", material.GetType()));
                
            }
            
        }
        /// <summary>
        /// eNX`WݒT{΍pɌp
        /// </summary>
        /// <param name="material">}eA</param>
        /// <param name="geometryCollection">WIgRNV</param>
        /// <param name="context">ReLXg</param>
        protected override void ProcessGeometryUsingMaterial(MaterialContent material, IEnumerable<GeometryContent> geometryCollection, ContentProcessorContext context)
        {
            //XtBA}bvŃeNX`WݒT{΍
            if (material.Textures.Count > 0)
            {
                foreach (var i in geometryCollection)
                {
                    bool flag = false;
                    int count = 0;
                    foreach (var channel in i.Vertices.Channels)
                    {
                        count = channel.Count;
                        if (channel.Name == VertexChannelNames.TextureCoordinate(0))
                        {
                            flag = true;
                            break;
                        }
                    }
                    if (!flag)
                    {//ݒ肳ĂȂ̂ŃeNX`ޔ
                        if (material.OpaqueData.ContainsKey("sphTex"))
                            throw new InvalidContentException("XtBA}bvp̃eNX`2m܂");
                        material.OpaqueData.Add("sphTex", 0);
                        material.Name = material.Textures["Texture"].Filename;
                        material.Textures.Clear();    
                    }
                }
            }
            base.ProcessGeometryUsingMaterial(material, geometryCollection, context);
        }
        
    }
}